/* vytvo databzi */
/* DOPX0001 .. nahrate svmi daty */
/* C:\Program Files\Microsoft SQL Server\MSSQL$VARIO\Data\ .. nahrate svou cestou */

CREATE DATABASE [DOPX0001]  ON (NAME = N'DOPX0001_dat', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL$VARIO\Data\DOPX0001.mdf' , SIZE = 2, FILEGROWTH = 10%) LOG ON (NAME = N'DOPX0001_log', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL$VARIO\Data\DOPX0001.ldf' , SIZE = 1, FILEGROWTH = 10%)
 COLLATE Czech_CI_AS
GO

exec sp_dboption N'DOPX0001', N'autoclose', N'true'
GO

exec sp_dboption N'DOPX0001', N'bulkcopy', N'false'
GO

exec sp_dboption N'DOPX0001', N'trunc. log', N'true'
GO

exec sp_dboption N'DOPX0001', N'torn page detection', N'true'
GO

exec sp_dboption N'DOPX0001', N'read only', N'false'
GO

exec sp_dboption N'DOPX0001', N'dbo use', N'false'
GO

exec sp_dboption N'DOPX0001', N'single', N'false'
GO

exec sp_dboption N'DOPX0001', N'autoshrink', N'true'
GO

exec sp_dboption N'DOPX0001', N'ANSI null default', N'false'
GO

exec sp_dboption N'DOPX0001', N'recursive triggers', N'false'
GO

exec sp_dboption N'DOPX0001', N'ANSI nulls', N'false'
GO

exec sp_dboption N'DOPX0001', N'concat null yields null', N'false'
GO

exec sp_dboption N'DOPX0001', N'cursor close on commit', N'false'
GO

exec sp_dboption N'DOPX0001', N'default to local cursor', N'false'
GO

exec sp_dboption N'DOPX0001', N'quoted identifier', N'false'
GO

exec sp_dboption N'DOPX0001', N'ANSI warnings', N'false'
GO

exec sp_dboption N'DOPX0001', N'auto create statistics', N'true'
GO

exec sp_dboption N'DOPX0001', N'auto update statistics', N'true'
GO

if( (@@microsoftversion / power(2, 24) = 8) and (@@microsoftversion & 0xffff >= 724) )
	exec sp_dboption N'DOPX0001', N'db chaining', N'false'
GO

use [DOPX0001]
GO

CREATE TABLE [dbo].[Barvy] (
	[ID_barvy] [smallint] NOT NULL ,
	[Barva] [nvarchar] (50) COLLATE Czech_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Definice_radku] (
	[Nazev_verze] [nvarchar] (50) COLLATE Czech_CI_AS NOT NULL ,
	[ID] [smallint] NOT NULL ,
	[ID_pom] [smallint] NULL ,
	[Popis] [nvarchar] (100) COLLATE Czech_CI_AS NULL ,
	[Stredisko] [nvarchar] (30) COLLATE Czech_CI_AS NULL ,
	[Vzorec_souctu] [nvarchar] (255) COLLATE Czech_CI_AS NULL ,
	[Druh_radku] [nvarchar] (1) COLLATE Czech_CI_AS NULL ,
	[Barva_pisma] [int] NULL ,
	[Barva_bunky] [int] NULL ,
	[Tucne] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Definice_radku_soucty] (
	[ID] [smallint] NOT NULL ,
	[Verze] [nvarchar] (50) COLLATE Czech_CI_AS NOT NULL ,
	[ID_souctu] [smallint] NOT NULL ,
	[ID_pom] [smallint] NULL ,
	[Odecist] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Nastaveni_doplnku] (
	[Nazev_polozky] [nvarchar] (50) COLLATE Czech_CI_AS NOT NULL ,
	[Hodnota_polozky] [nvarchar] (255) COLLATE Czech_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Prava] (
	[Jmeno] [nvarchar] (50) COLLATE Czech_CI_AS NOT NULL ,
	[Pravo_definice_radku] [bit] NOT NULL ,
	[Pravo_export] [bit] NOT NULL ,
	[Pravo_admin] [bit] NOT NULL ,
	[Pass] [nvarchar] (50) COLLATE Czech_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Sloupce] (
	[CisloSloupce] [smallint] NOT NULL ,
	[Sloupec] [nvarchar] (2) COLLATE Czech_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Strediska_detail] (
	[Stredisko_sumarne] [nvarchar] (50) COLLATE Czech_CI_AS NOT NULL ,
	[Stredisko] [nvarchar] (50) COLLATE Czech_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Strediska_sumarne] (
	[Stredisko_sumarne] [nvarchar] (50) COLLATE Czech_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Verze_dat] (
	[Verze] [nvarchar] (50) COLLATE Czech_CI_AS NOT NULL ,
	[Zmeny] [nvarchar] (255) COLLATE Czech_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Verze_seznam] (
	[Nazev_verze] [nvarchar] (50) COLLATE Czech_CI_AS NOT NULL ,
	[Poznamka] [nvarchar] (255) COLLATE Czech_CI_AS NULL ,
	[Autor] [nvarchar] (50) COLLATE Czech_CI_AS NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Barvy] ADD 
	CONSTRAINT [DF__Barvy__ID_barvy__239E4DCF] DEFAULT (0) FOR [ID_barvy],
	CONSTRAINT [aaaaaBarvy_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[ID_barvy]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [ID_barvy] ON [dbo].[Barvy]([ID_barvy]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Definice_radku] ADD 
	CONSTRAINT [DF__Definice_rad__ID__1CF15040] DEFAULT (0) FOR [ID],
	CONSTRAINT [DF__Definice___ID_po__1DE57479] DEFAULT (0) FOR [ID_pom],
	CONSTRAINT [DF__Definice___Tucne__1ED998B2] DEFAULT (0) FOR [Tucne],
	CONSTRAINT [aaaaaDefinice_radku_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[Nazev_verze],
		[ID]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [ID] ON [dbo].[Definice_radku]([ID]) ON [PRIMARY]
GO

 CREATE  INDEX [ID_pom] ON [dbo].[Definice_radku]([ID_pom]) ON [PRIMARY]
GO

 CREATE  INDEX [Verze_seznamDefinice_radku] ON [dbo].[Definice_radku]([Nazev_verze]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Definice_radku_soucty] ADD 
	CONSTRAINT [DF__Definice_rad__ID__15502E78] DEFAULT (0) FOR [ID],
	CONSTRAINT [DF__Definice___ID_so__164452B1] DEFAULT (0) FOR [ID_souctu],
	CONSTRAINT [DF__Definice___ID_po__173876EA] DEFAULT (0) FOR [ID_pom],
	CONSTRAINT [DF__Definice___Odeci__182C9B23] DEFAULT (0) FOR [Odecist],
	CONSTRAINT [aaaaaDefinice_radku_soucty_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[ID],
		[Verze],
		[ID_souctu]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [ID] ON [dbo].[Definice_radku_soucty]([ID_souctu]) ON [PRIMARY]
GO

 CREATE  INDEX [ID_pom] ON [dbo].[Definice_radku_soucty]([ID_pom]) ON [PRIMARY]
GO

 CREATE  INDEX [ID1] ON [dbo].[Definice_radku_soucty]([ID]) ON [PRIMARY]
GO

 CREATE  INDEX [Verze_seznamDefinice_radku_soucty] ON [dbo].[Definice_radku_soucty]([Verze]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Nastaveni_doplnku] ADD 
	CONSTRAINT [aaaaaNastaveni_doplnku_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[Nazev_polozky]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [ID] ON [dbo].[Nastaveni_doplnku]([Nazev_polozky]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Prava] ADD 
	CONSTRAINT [DF__Prava__Pravo_def__0AD2A005] DEFAULT (0) FOR [Pravo_definice_radku],
	CONSTRAINT [DF__Prava__Pravo_exp__0BC6C43E] DEFAULT (0) FOR [Pravo_export],
	CONSTRAINT [DF__Prava__Pravo_adm__0CBAE877] DEFAULT (0) FOR [Pravo_admin],
	CONSTRAINT [aaaaaPrava_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[Jmeno]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Sloupce] ADD 
	CONSTRAINT [DF__Sloupce__CisloSl__060DEAE8] DEFAULT (0) FOR [CisloSloupce],
	CONSTRAINT [aaaaaSloupce_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[CisloSloupce]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Strediska_detail] ADD 
	CONSTRAINT [aaaaaStrediska_detail_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[Stredisko_sumarne],
		[Stredisko]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [Strediska_sumarneStrediska_detail] ON [dbo].[Strediska_detail]([Stredisko_sumarne]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Strediska_sumarne] ADD 
	CONSTRAINT [aaaaaStrediska_sumarne_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[Stredisko_sumarne]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Verze_dat] ADD 
	CONSTRAINT [aaaaaVerze_dat_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[Verze]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Verze_seznam] ADD 
	CONSTRAINT [aaaaaVerze_seznam_PK] PRIMARY KEY  NONCLUSTERED 
	(
		[Nazev_verze]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Definice_radku] ADD 
	CONSTRAINT [Definice_radku_FK00] FOREIGN KEY 
	(
		[Nazev_verze]
	) REFERENCES [dbo].[Verze_seznam] (
		[Nazev_verze]
	)
GO

alter table [dbo].[Definice_radku] nocheck constraint [Definice_radku_FK00]
GO

ALTER TABLE [dbo].[Definice_radku_soucty] ADD 
	CONSTRAINT [Definice_radku_soucty_FK00] FOREIGN KEY 
	(
		[Verze]
	) REFERENCES [dbo].[Verze_seznam] (
		[Nazev_verze]
	)
GO

alter table [dbo].[Definice_radku_soucty] nocheck constraint [Definice_radku_soucty_FK00]
GO

ALTER TABLE [dbo].[Strediska_detail] ADD 
	CONSTRAINT [Strediska_detail_FK00] FOREIGN KEY 
	(
		[Stredisko_sumarne]
	) REFERENCES [dbo].[Strediska_sumarne] (
		[Stredisko_sumarne]
	)
GO

alter table [dbo].[Strediska_detail] nocheck constraint [Strediska_detail_FK00]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Definice_radku_UTrig ON [Definice_radku] FOR UPDATE AS
SET NOCOUNT ON
/* * ZAMEZIT AKTUALIZACM, NEN-LI V Verze_seznam ODPOVDAJC KL */
IF UPDATE(Nazev_verze)
    BEGIN
        IF (SELECT COUNT(*) FROM inserted) !=
           (SELECT COUNT(*) FROM Verze_seznam, inserted WHERE (Verze_seznam.Nazev_verze = inserted.Nazev_verze))
            BEGIN
                RAISERROR 44446 'Zznam nelze odstranit ani zmnit. Pravidla referenn integrity vyaduj, aby v tabulce Verze_seznam existoval souvisejc zznam.'
                ROLLBACK TRANSACTION
            END
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Definice_radku_ITrig ON [Definice_radku] FOR INSERT AS
SET NOCOUNT ON
/* * ZAMEZIT VKLDN, NEN-LI V Verze_seznam ODPOVDAJC KL */
IF (SELECT COUNT(*) FROM inserted) !=
   (SELECT COUNT(*) FROM Verze_seznam, inserted WHERE (Verze_seznam.Nazev_verze = inserted.Nazev_verze))
    BEGIN
        RAISERROR 44447 'Zznam nelze odstranit ani zmnit. Pravidla referenn integrity vyaduj, aby v tabulce Verze_seznam existoval souvisejc zznam.'
        ROLLBACK TRANSACTION
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Definice_radku_soucty_UTrig ON [Definice_radku_soucty] FOR UPDATE AS
SET NOCOUNT ON
/* * ZAMEZIT AKTUALIZACM, NEN-LI V Verze_seznam ODPOVDAJC KL */
IF UPDATE(Verze)
    BEGIN
        IF (SELECT COUNT(*) FROM inserted) !=
           (SELECT COUNT(*) FROM Verze_seznam, inserted WHERE (Verze_seznam.Nazev_verze = inserted.Verze))
            BEGIN
                RAISERROR 44446 'Zznam nelze odstranit ani zmnit. Pravidla referenn integrity vyaduj, aby v tabulce Verze_seznam existoval souvisejc zznam.'
                ROLLBACK TRANSACTION
            END
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Definice_radku_soucty_ITrig ON [Definice_radku_soucty] FOR INSERT AS
SET NOCOUNT ON
/* * ZAMEZIT VKLDN, NEN-LI V Verze_seznam ODPOVDAJC KL */
IF (SELECT COUNT(*) FROM inserted) !=
   (SELECT COUNT(*) FROM Verze_seznam, inserted WHERE (Verze_seznam.Nazev_verze = inserted.Verze))
    BEGIN
        RAISERROR 44447 'Zznam nelze odstranit ani zmnit. Pravidla referenn integrity vyaduj, aby v tabulce Verze_seznam existoval souvisejc zznam.'
        ROLLBACK TRANSACTION
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Strediska_detail_UTrig ON [Strediska_detail] FOR UPDATE AS
SET NOCOUNT ON
/* * ZAMEZIT AKTUALIZACM, NEN-LI V Strediska_sumarne ODPOVDAJC KL */
IF UPDATE(Stredisko_sumarne)
    BEGIN
        IF (SELECT COUNT(*) FROM inserted) !=
           (SELECT COUNT(*) FROM Strediska_sumarne, inserted WHERE (Strediska_sumarne.Stredisko_sumarne = inserted.Stredisko_sumarne))
            BEGIN
                RAISERROR 44446 'Zznam nelze odstranit ani zmnit. Pravidla referenn integrity vyaduj, aby v tabulce Strediska_sumarne existoval souvisejc zznam.'
                ROLLBACK TRANSACTION
            END
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Strediska_detail_ITrig ON [Strediska_detail] FOR INSERT AS
SET NOCOUNT ON
/* * ZAMEZIT VKLDN, NEN-LI V Strediska_sumarne ODPOVDAJC KL */
IF (SELECT COUNT(*) FROM inserted) !=
   (SELECT COUNT(*) FROM Strediska_sumarne, inserted WHERE (Strediska_sumarne.Stredisko_sumarne = inserted.Stredisko_sumarne))
    BEGIN
        RAISERROR 44447 'Zznam nelze odstranit ani zmnit. Pravidla referenn integrity vyaduj, aby v tabulce Strediska_sumarne existoval souvisejc zznam.'
        ROLLBACK TRANSACTION
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Strediska_sumarne_UTrig ON [Strediska_sumarne] FOR UPDATE AS
SET NOCOUNT ON
/* * KASKDOV AKTUALIZACE Strediska_detail */
IF UPDATE(Stredisko_sumarne)
    BEGIN
       UPDATE Strediska_detail
       SET Strediska_detail.Stredisko_sumarne = inserted.Stredisko_sumarne
       FROM Strediska_detail, deleted, inserted
       WHERE deleted.Stredisko_sumarne = Strediska_detail.Stredisko_sumarne
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Strediska_sumarne_DTrig ON [Strediska_sumarne] FOR DELETE AS
SET NOCOUNT ON
/* * ZAMEZIT ODSTRAOVN, JSOU-LI V Strediska_detail SOUVISEJC ZZNAMY */
IF (SELECT COUNT(*) FROM deleted, Strediska_detail WHERE (deleted.Stredisko_sumarne = Strediska_detail.Stredisko_sumarne)) > 0
    BEGIN
        RAISERROR 44445 'Zznam nelze odstranit ani zmnit. Dolo by k poruen pravidel referenn integrity, protoe v tabulce Strediska_detail existuj souvisejc zznamy.'
        ROLLBACK TRANSACTION
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Verze_seznam_UTrig ON [Verze_seznam] FOR UPDATE AS
SET NOCOUNT ON
/* * KASKDOV AKTUALIZACE Definice_radku */
IF UPDATE(Nazev_verze)
    BEGIN
       UPDATE Definice_radku
       SET Definice_radku.Nazev_verze = inserted.Nazev_verze
       FROM Definice_radku, deleted, inserted
       WHERE deleted.Nazev_verze = Definice_radku.Nazev_verze
    END

/* * KASKDOV AKTUALIZACE Definice_radku_soucty */
IF UPDATE(Nazev_verze)
    BEGIN
       UPDATE Definice_radku_soucty
       SET Definice_radku_soucty.Verze = inserted.Nazev_verze
       FROM Definice_radku_soucty, deleted, inserted
       WHERE deleted.Nazev_verze = Definice_radku_soucty.Verze
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER T_Verze_seznam_DTrig ON [Verze_seznam] FOR DELETE AS
SET NOCOUNT ON
/* * ZAMEZIT ODSTRAOVN, JSOU-LI V Definice_radku SOUVISEJC ZZNAMY */
IF (SELECT COUNT(*) FROM deleted, Definice_radku WHERE (deleted.Nazev_verze = Definice_radku.Nazev_verze)) > 0
    BEGIN
        RAISERROR 44445 'Zznam nelze odstranit ani zmnit. Dolo by k poruen pravidel referenn integrity, protoe v tabulce Definice_radku existuj souvisejc zznamy.'
        ROLLBACK TRANSACTION
    END

/* * ZAMEZIT ODSTRAOVN, JSOU-LI V Definice_radku_soucty SOUVISEJC ZZNAMY */
IF (SELECT COUNT(*) FROM deleted, Definice_radku_soucty WHERE (deleted.Nazev_verze = Definice_radku_soucty.Verze)) > 0
    BEGIN
        RAISERROR 44445 'Zznam nelze odstranit ani zmnit. Dolo by k poruen pravidel referenn integrity, protoe v tabulce Definice_radku_soucty existuj souvisejc zznamy.'
        ROLLBACK TRANSACTION
    END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

